// ASHE (PC88) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x100*16*80];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{
	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

struct fpos
{
	int trk;
	int sec;
	int size;
};

int main(int argc, char *argv[])
{
	char fname[11];
	int i,d;
	int disk2=0;
	int musnum=0;
	unsigned char id1[] = "ASHEA";
	unsigned char id2[] = "BDISK";
	unsigned char id3[] = "DSKCH";

	struct fpos md1[] =
	{
		{ 0x30, 0x01, 0x1a00 },	// I[vjO2
		{ 0x24, 0x01, 0x1a00 },	// I[vjO2(gpo[W)
		{ 0x26, 0x01, 0x0c00 },	// CBGM
		{ 0x27, 0x01, 0x0c00 },	// Q[I[o[
		{ 0x28, 0x01, 0x0c00 },
		{ 0x29, 0x01, 0x0c00 },
		{ 0x2a, 0x01, 0x0c00 },
		{ 0x2b, 0x01, 0x0c00 },
		{ 0x2c, 0x01, 0x0c00 },
		{ 0x2e, 0x01, 0x0c00 },	// I[vjO1
		{ 0x2f, 0x01, 0x0c00 },	// ̃e[}
		{ 0x32, 0x01, 0x0c00 },
		{ 0x00, 0x00, 0x0000 }, // End of Data
	};

	struct fpos md2[] =
	{
		{ 0x00, 0x00, 0x0000 }, // End of Data
	};

	if (argc != 2) {
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1])) {
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();
	for (d=0; d<numdisk; d++)
	{
		disk.SelectDisk(d);
		disk.SetRecordRange(0x01,0x10);
		disk.ReadDATA1(0x03, 0x01, 0x01, 0x0f, 0x01, buff, 0x100);
		if (!memcmp(buff,id1,sizeof(id1)-1))
		{
			printf("Game Disk F܂. \n");
			fcut("DRIVER", 0x37, 0x1b, 0x01, 0x09, 0x01, 0x0000, 0x2800);
			for (i=0; md1[i].sec; i++)
			{
				sprintf(fname,"MUS%02d",musnum++);
				fcut(fname, md1[i].trk, md1[i].trk>>1, md1[i].trk&1, md1[i].sec, 0x01, 0x0000, md1[i].size);
			}
			continue;
		}
		disk.ReadDATA1(0x4f, 0x27, 0x01, 0x0d, 0x01, buff, 0x100);
#if 0
		if (!memcmp(buff,id2,sizeof(id2)-1) || !memcmp(buff,id3,sizeof(id3)-1))
		{
			if (!memcmp(buff,id2,sizeof(id2)-1))
			{
				printf("Data Disk F܂.\n");
			}
			else
			{
				printf("Character Disk F܂.\n");
			}
			if (disk2) continue;		// ɐ؂oς݂̏ꍇ
			for (i=0; md2[i].sec; i++)
			{
				sprintf(fname,"MUS%02d",musnum++);
				fcut(fname, md2[i].trk, md2[i].trk>>1, md2[i].trk&1, md2[i].sec, 0x01, 0x0000, md2[i].size);
			}
			disk2++;
		}
#endif
	}
	return 0;
}

